
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Cms_pagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const cms_pages = await db.cms_pages.create(
            {
                id: data.id || undefined,
        
        page_key: data.page_key
        ||
        null
            ,
            
        title_ar: data.title_ar
        ||
        null
            ,
            
        title_en: data.title_en
        ||
        null
            ,
            
        content_ar: data.content_ar
        ||
        null
            ,
            
        content_en: data.content_en
        ||
        null
            ,
            
        is_published: data.is_published
        ||
        false
        
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return cms_pages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const cms_pagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                page_key: item.page_key
            ||
            null
            ,
            
                title_ar: item.title_ar
            ||
            null
            ,
            
                title_en: item.title_en
            ||
            null
            ,
            
                content_ar: item.content_ar
            ||
            null
            ,
            
                content_en: item.content_en
            ||
            null
            ,
            
                is_published: item.is_published
            ||
            false
        
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const cms_pages = await db.cms_pages.bulkCreate(cms_pagesData, { transaction });

        // For each item created, replace relation files
        

        return cms_pages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const cms_pages = await db.cms_pages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.page_key !== undefined) updatePayload.page_key = data.page_key;
        
        
        if (data.title_ar !== undefined) updatePayload.title_ar = data.title_ar;
        
        
        if (data.title_en !== undefined) updatePayload.title_en = data.title_en;
        
        
        if (data.content_ar !== undefined) updatePayload.content_ar = data.content_ar;
        
        
        if (data.content_en !== undefined) updatePayload.content_en = data.content_en;
        
        
        if (data.is_published !== undefined) updatePayload.is_published = data.is_published;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await cms_pages.update(updatePayload, {transaction});

        
        

        
        

        

        return cms_pages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const cms_pages = await db.cms_pages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of cms_pages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of cms_pages) {
                await record.destroy({transaction});
            }
        });


        return cms_pages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const cms_pages = await db.cms_pages.findByPk(id, options);

        await cms_pages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await cms_pages.destroy({
            transaction
        });

        return cms_pages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const cms_pages = await db.cms_pages.findOne(
            { where },
            { transaction },
        );

        if (!cms_pages) {
            return cms_pages;
        }

        const output = cms_pages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'cms_pages',
                        'title_ar',
                        filter.title_ar,
                    ),
                };
            }
            
            if (filter.title_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'cms_pages',
                        'title_en',
                        filter.title_en,
                    ),
                };
            }
            
            if (filter.content_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'cms_pages',
                        'content_ar',
                        filter.content_ar,
                    ),
                };
            }
            
            if (filter.content_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'cms_pages',
                        'content_en',
                        filter.content_en,
                    ),
                };
            }
            

            
            

            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.page_key) {
                where = {
                    ...where,
                page_key: filter.page_key,
            };
            }
            
            if (filter.is_published) {
                where = {
                    ...where,
                is_published: filter.is_published,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.cms_pages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'cms_pages',
                        'title_ar',
                        query,
                    ),
                ],
            };
        }

        const records = await db.cms_pages.findAll({
            attributes: [ 'id', 'title_ar' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title_ar', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title_ar,
        }));
    }

    
};

